Package org.codehaus.groovy.classgen.asm.sc

# Class StaticTypesCallSiteWriter

java.lang.Object
org.codehaus.groovy.classgen.asm.CallSiteWriter
org.codehaus.groovy.classgen.asm.sc.StaticTypesCallSiteWriter

public class StaticTypesCallSiteWriter extends CallSiteWriter
A call site writer which replaces call site caching with static calls. This means that the generated code looks more like Java code than dynamic Groovy code. Best effort is made to use JVM instructions instead of calls to helper methods.

- ## Field Summary

  ### Fields inherited from class org.codehaus.groovy.classgen.asm.CallSiteWriter

  `CONSTRUCTOR`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StaticTypesCallSiteWriter(StaticTypesWriterController controller)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `fallbackAttributeOrPropertySite(PropertyExpression expression, Expression objectExpression, String name, MethodCallerMultiAdapter adapter)`
  `void`
  `generateCallSiteArray()`
  `void`
  `makeCallSite(Expression receiver, String message, Expression arguments, boolean safe, boolean implicitThis, boolean callCurrent, boolean callStatic)`
  `void`
  `makeCallSiteArrayInitializer()`
  `void`
  `makeGetPropertySite(Expression receiver, String propertyName, boolean safe, boolean implicitThis)`
  `void`
  `makeGroovyObjectGetPropertySite(Expression receiver, String propertyName, boolean safe, boolean implicitThis)`
  `void`
  `makeSingleArgumentCall(Expression receiver, String message, Expression argument, boolean safe)`
  `void`
  `makeSiteEntry()`
  `void`
  `prepareCallSite(String message)`

  ### Methods inherited from class org.codehaus.groovy.classgen.asm.CallSiteWriter

  `getCallSites, hasCallSiteUse, makeSingleArgumentCall, prepareSiteAndReceiver, visitBoxedArgument`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### StaticTypesCallSiteWriter

    public StaticTypesCallSiteWriter(StaticTypesWriterController controller)

- ## Method Details

  - ### generateCallSiteArray

    public void generateCallSiteArray()
    Overrides:
      `generateCallSiteArray` in class `CallSiteWriter`

  - ### makeCallSite

    public void makeCallSite(Expression receiver, String message, Expression arguments, boolean safe, boolean implicitThis, boolean callCurrent, boolean callStatic)
    Overrides:
      `makeCallSite` in class `CallSiteWriter`

  - ### makeGetPropertySite

    public void makeGetPropertySite(Expression receiver, String propertyName, boolean safe, boolean implicitThis)
    Overrides:
      `makeGetPropertySite` in class `CallSiteWriter`

  - ### makeGroovyObjectGetPropertySite

    public void makeGroovyObjectGetPropertySite(Expression receiver, String propertyName, boolean safe, boolean implicitThis)
    Overrides:
      `makeGroovyObjectGetPropertySite` in class `CallSiteWriter`

  - ### makeCallSiteArrayInitializer

    public void makeCallSiteArrayInitializer()
    Overrides:
      `makeCallSiteArrayInitializer` in class `CallSiteWriter`

  - ### makeSiteEntry

    public void makeSiteEntry()
    Overrides:
      `makeSiteEntry` in class `CallSiteWriter`

  - ### prepareCallSite

    public void prepareCallSite(String message)
    Overrides:
      `prepareCallSite` in class `CallSiteWriter`

  - ### makeSingleArgumentCall

    public void makeSingleArgumentCall(Expression receiver, String message, Expression argument, boolean safe)
    Overrides:
      `makeSingleArgumentCall` in class `CallSiteWriter`

  - ### fallbackAttributeOrPropertySite

    public void fallbackAttributeOrPropertySite(PropertyExpression expression, Expression objectExpression, String name, MethodCallerMultiAdapter adapter)
    Overrides:
      `fallbackAttributeOrPropertySite` in class `CallSiteWriter`